#include "analog_calibration.h"


int16_t analog_calibration_apply(analog_calibration_t const *calibration, int16_t input)
{
    const int16_t relative_input = input - calibration->input_neutral; // -512..511
    const int16_t scaled_input = ((int32_t) relative_input * calibration->scale) >> 6;
    const int16_t output = scaled_input + calibration->output_neutral;
    return output;
}