#ifndef DATA_LINK_RX_H
#define DATA_LINK_RX_H

#include <stdint.h>
#include <stdbool.h>


typedef struct data_link_rx_t_
{
    uint16_t l_time;
    uint16_t h_time;
    bool last_bit;
    uint16_t data;
    uint8_t data_bits_n;
    bool start_condition;
} 
data_link_rx_t;


void data_link_rx_init(data_link_rx_t *data_link);
void data_link_rx_receive(data_link_rx_t *data_link, uint8_t wire_data);
bool data_link_rx_get_start_condition(data_link_rx_t *data_link);
bool data_link_rx_has_data(data_link_rx_t const *data_link);
uint8_t data_link_rx_get_data(data_link_rx_t *data_link);

#endif // DATA_LINK_RX_H