#include "data_link_tx.h"
#include <assert.h>


void data_link_tx_init(data_link_tx_t *data_link)
{
    data_link->data_length = 0;
}


void data_link_tx_send_start(data_link_tx_t *data_link)
{
    data_link->data_length = 2;
    data_link->data[DATA_LINK_TX_MAX_DATA_LENGTH - 2] = 0;
    data_link->data[DATA_LINK_TX_MAX_DATA_LENGTH - 1] = 1;
}


void data_link_tx_send_data(data_link_tx_t *data_link, uint8_t data)
{
    data_link->data_length = 3;

    data_link->data[DATA_LINK_TX_MAX_DATA_LENGTH - 3] = 0x24;
    data_link->data[DATA_LINK_TX_MAX_DATA_LENGTH - 3] |= (data & 0x80) ? 0x40 : 0x00;
    data_link->data[DATA_LINK_TX_MAX_DATA_LENGTH - 3] |= (data & 0x40) ? 0x08 : 0x00;
    data_link->data[DATA_LINK_TX_MAX_DATA_LENGTH - 3] |= (data & 0x20) ? 0x01 : 0x00;

    data_link->data[DATA_LINK_TX_MAX_DATA_LENGTH - 2] = 0x92;
    data_link->data[DATA_LINK_TX_MAX_DATA_LENGTH - 2] |= (data & 0x10) ? 0x20 : 0x00;
    data_link->data[DATA_LINK_TX_MAX_DATA_LENGTH - 2] |= (data & 0x08) ? 0x04 : 0x00;

    data_link->data[DATA_LINK_TX_MAX_DATA_LENGTH - 1] = 0x49;
    data_link->data[DATA_LINK_TX_MAX_DATA_LENGTH - 1] |= (data & 0x04) ? 0x80 : 0x00;
    data_link->data[DATA_LINK_TX_MAX_DATA_LENGTH - 1] |= (data & 0x02) ? 0x10 : 0x00;
    data_link->data[DATA_LINK_TX_MAX_DATA_LENGTH - 1] |= (data & 0x01) ? 0x02 : 0x00;
}


void data_link_tx_send_stop(data_link_tx_t *data_link)
{
    data_link->data_length = 1;
    data_link->data[DATA_LINK_TX_MAX_DATA_LENGTH - 1] = 0;
}

bool data_link_tx_has_wire_data(data_link_tx_t *data_link)
{
    return (data_link->data_length > 0);
}


uint8_t data_link_tx_get_wire_data(data_link_tx_t *data_link)
{
    --data_link->data_length;
    return data_link->data[DATA_LINK_TX_MAX_DATA_LENGTH - 1 - data_link->data_length];
}