#ifndef HAL_RX_H
#define HAL_RX_H

#include <stdint.h>
#include <stdbool.h>


typedef enum hal_rx_status_t_
{
    HAL_RX_STATUS_OK,
    HAL_RX_STATUS_BUFFER_OVERFLOW
}
hal_rx_status_t;

typedef void (*hal_rx_callback_t)(void *data, uint16_t time_ms);


#define OUTPUTS_N (7)


void hal_rx_init();
void hal_rx_log_write(const char *s);
hal_rx_status_t hal_rx_get_status();
bool hal_rx_has_rf_data();
uint8_t hal_rx_receive_rf_data();
void hal_rx_set_status_led(bool is_enabled);
void hal_rx_set_timer_callback(hal_rx_callback_t callback, void *data);
void hal_rx_drive_motor(int8_t speed);
void hal_rx_drive_servo1(int16_t t_us);
void hal_rx_drive_servo2(int16_t t_us);
void hal_rx_set_pwm_output(uint8_t duty_cycle);
void hal_rx_set_gp_output(uint8_t index, bool value);

#endif // HAL_RX_H